VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ProtocolHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Implement IInternetProtocol
Implements olelib2.IInternetProtocol

' Private members
Private m_oSink As IInternetProtocolSink  ' Callback object used to inform
                                          ' the progress
Private m_sDatabase As String             ' Filename of the database to show
Private m_sTableName As String            ' Table name
Private m_sTempFile As String             ' Temporary file used to render the HTML
Private m_lFile As Long                   ' File handle
Private m_bDownloadDone As Boolean        ' Flag used to know if all the data has been readed

'Const MIMETYPE = "text/html"              ' Mime type returned by this protocol
'Const MIMETYPE = "image/jpeg"

Private Enum Errors
   errCannotOpenConnection
   errCannotOpenRecordset
   errInvalidURL
   errCannotOpenFile
   DebugString
End Enum

Private m_oRS As DAO.Recordset
Private db As DAO.Database
Private ReadInProcess As Boolean
Private Offset As Long
Private PicSize As Long
'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)



' ParseURL
' Parses the URL. Returns False if the URL can't be parsed.
Private Function ParseURL(ByVal URL As String) As Boolean
Dim lPos As Long
On Error GoTo InvalidURL
' Unescape the URL
UrlUnescape URL, URL, Len(URL), URL_UNESCAPE_INPLACE
' Remove the protocol
URL = Mid$(URL, InStr(URL, ":") + 1)
' Remove the / at the end of the URL
If Right$(URL, 1) = "/" Then URL = Left$(URL, Len(URL) - 1)
' Remove the // at the begining of the URL
Do While Left$(URL, 1) = "/"
 URL = Mid$(URL, 2)
Loop
' Find the first / from the right
lPos = InStrRev(URL, "/")
If lPos > 0 Then
    ' Get the file name
    'rsview://c:\db.mdb/Select Picture From Storage Where Key = 1
    m_sDatabase = Left$(URL, lPos - 1)   'c:\db.mdb
    m_sTableName = RTrimNull(Mid$(URL, lPos + 1))   'Select Picture From Storage Where Key = 1
    If Left$(m_sDatabase, 2) = "\\" Then
        m_sDatabase = Mid$(m_sDatabase, 3)
    End If
    ParseURL = True
End If
InvalidURL:
Err.Clear
End Function

Private Sub Class_Initialize()
Dim oPH As IInternetProtocol
   ' Get the IInternetProtocol interface
   Set oPH = Me
   ' Replace the Read method
   ReplaceVTableEntry ObjPtr(oPH), 10, AddressOf mdlProtocolHandler.IInternetProtocol_Read
End Sub


Private Sub IInternetProtocol_Continue(pProtocolData As olelib.PROTOCOLDATA)
WriteError DebugString, "IInternetProtocol_Continue"
   Err.Raise E_NOTIMPL
End Sub

Private Sub IInternetProtocol_LockRequest(ByVal dwOptions As Long)
WriteError DebugString, "IInternetProtocol_LockRequest"
   Err.Raise E_NOTIMPL
End Sub

Private Sub IInternetProtocol_Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long)
   ' This member is replaced with the function in the .bas module
End Sub

' Reads the data
Friend Function Read(ByVal pv As Long, ByVal cb As Long, pcbRead As Long) As Long

Dim abBuffer() As Byte

On Error Resume Next
'WriteError DebugString, Time & " Read " & m_oRS(0).Name

If Not ReadInProcess Then

    PicSize = m_oRS.Fields(0).FieldSize
    Offset = 0
    ReadInProcess = True
    
    ' Report progress
    m_oSink.ReportData BSCF_INTERMEDIATEDATANOTIFICATION, 0, 0
    ' Nothing was readed here
    pcbRead = 0
    ' Return E_PENDING
    Read = &H8000000A

WriteError DebugString, Time & "  " & m_oRS(0).Name & " " & PicSize

Else 'ReadInProcess

    ' Check if the file was completly readed by the caller. You have to check this because Read can be called after the whole file was readed.
    If Not m_bDownloadDone Then

        On Error Resume Next

        ' Read from rs
        ReDim abBuffer(0 To cb - 1)
        abBuffer() = m_oRS.Fields(0).GetChunk(Offset, cb)
        
        If Offset + cb > PicSize Then
            Offset = PicSize - Offset
        Else
            Offset = Offset + cb
        End If
        
        ' Copy the data to the buffer
        MoveMemory ByVal pv, abBuffer(0), cb
        
        ' Return how many bytes were readed
        pcbRead = cb
        ' Report progress
        m_oSink.ReportData BSCF_INTERMEDIATEDATANOTIFICATION, 0, 0
        
WriteError DebugString, " " & cb & "  " & Offset

        If Offset >= PicSize Then
            ' The file was complety readed

            ' Report that this is the last data chunk
            m_oSink.ReportData BSCF_LASTDATANOTIFICATION, 100, 100
            m_oSink.ReportProgress BINDSTATUS_ENDDOWNLOADDATA, ""

            ' Report the result code
            m_oSink.ReportResult 0, 0, 0

            m_bDownloadDone = True

            ' Close the recordset
            m_oRS.Close:  Set m_oRS = Nothing
            db.Close: Set db = Nothing
            
WriteError DebugString, ""
        End If
    Else
        ' Nothing readed
        pcbRead = 0
        ' Return S_FALSE to notify the caller that all the data has been readed
        Read = S_FALSE
    End If
End If
End Function

Private Sub IInternetProtocol_Resume()
WriteError DebugString, "IInternetProtocol_Resume"
   Err.Raise E_NOTIMPL
End Sub

Private Sub IInternetProtocol_Seek(ByVal dlibMove As Currency, ByVal dwOrigin As Long, plibNewPosition As Currency)
WriteError DebugString, "IInternetProtocol_Seek"
   Err.Raise E_NOTIMPL
End Sub

Private Sub IInternetProtocol_Start(ByVal szUrl As Long, ByVal pOIProtSink As olelib2.IInternetProtocolSink, ByVal pOIBindInfo As olelib.IInternetBindInfo, ByVal grfPI As olelib.PI_FLAGS, dwReserved As olelib.PROTOCOLFILTERDATA)

On Error GoTo fail
' Create the debug file
m_sTempFile = Environ$("TEMP") & "\debug " & Date
m_lFile = FreeFile
Open m_sTempFile For Append As m_lFile 'Output As m_lFile
On Error GoTo 0

WriteError DebugString, vbNullString
WriteError DebugString, "IInternetProtocol_Start"

' Store the sink object
Set m_oSink = pOIProtSink

' Parse the URL
If ParseURL(SysAllocString(szUrl)) Then

    ' Report progress
    m_oSink.ReportProgress BINDSTATUS_FINDINGRESOURCE, m_sTableName
    m_oSink.ReportProgress BINDSTATUS_CONNECTING, m_sTableName

    On Error GoTo CantConnect

    ' Open the connection to the database
    Set db = DBEngine.OpenDatabase(m_sDatabase, True, True)

    On Error GoTo CantGetRecordset

    ' Open the connection to recordset
    Set m_oRS = db.OpenRecordset(m_sTableName)

'    On Error GoTo Fail

Else
    WriteError errInvalidURL
End If

ReportProgress:

' Send the MIME type to the caller
'm_oSink.ReportProgress BINDSTATUS_MIMETYPEAVAILABLE, MIMETYPE
'm_oSink.ReportProgress BINDSTATUS_VERIFIEDMIMETYPEAVAILABLE, MIMETYPE

' Send the BEGINDOWNLOADDATA message to the caller
m_oSink.ReportProgress BINDSTATUS_BEGINDOWNLOADDATA, ""

Exit Sub



CantConnect:
WriteError errCannotOpenConnection, Err.Description
Resume ReportProgress

CantGetRecordset:
WriteError errCannotOpenRecordset, Err.Description
Resume ReportProgress

fail:
WriteError DebugString, "FAIL"
On Error GoTo 0
m_oSink.ReportResult INET_E_DOWNLOAD_FAILURE, 0, 0
Err.Raise INET_E_DOWNLOAD_FAILURE
End Sub

Private Sub IInternetProtocol_Suspend()
WriteError DebugString, "IInternetProtocol_Suspend"
   Err.Raise E_NOTIMPL
End Sub


Private Sub IInternetProtocol_Terminate(ByVal dwOptions As Long)
' 
On Error Resume Next
WriteError DebugString, "IInternetProtocol_Terminate"

Set m_oSink = Nothing
Close #m_lFile

'Kill m_sTempFile 'Delete the temporary file
End Sub
Private Sub IInternetProtocol_Abort(ByVal hrReason As Long, ByVal dwOptions As Long)
On Error Resume Next
WriteError DebugString, "IInternetProtocol_Abort"

' Reset all variables
m_sDatabase = vbNullString
m_sTableName = vbNullString
m_sTempFile = vbNullString
m_lFile = 0

ReadInProcess = False
Offset = 0
PicSize = 0

' Release the objects
m_oRS.Close: Set m_oRS = Nothing: db.Close: Set db = Nothing
Set m_oSink = Nothing
End Sub

Private Sub IInternetProtocol_UnlockRequest()
WriteError DebugString, "IInternetProtocol_UnlockRequest"
   Err.Raise E_NOTIMPL
End Sub

' Writes an error file that will be returned by this handler.
Private Sub WriteError(ByVal ErrType As Errors, Optional ByVal Desc As String)
On Error Resume Next
Select Case ErrType
Case errInvalidURL:
    Print #m_lFile, "Invalid URL"
    Print #m_lFile, "The URL must be in the following form:"
    Print #m_lFile, "rsview://database.mdb/SQL Statement"
Case errCannotOpenConnection
    Print #m_lFile, "Can't open the database connection for "; m_sDatabase
    Print #m_lFile, Desc
    Print #m_lFile, "Database: "; m_sDatabase
Case errCannotOpenRecordset
    Print #m_lFile, "There was an error executing the query"
    Print #m_lFile, Desc
    Print #m_lFile, "Query: "; m_sTableName
    Print #m_lFile, "Database: "; m_sDatabase
Case errCannotOpenFile
    Print #m_lFile, "Can't create temporary file"
Case DebugString
    Print #m_lFile, Desc
End Select
End Sub

